=== src/xilinx-efct-1.2.5.0/include/linux/Makefile ===
# SPDX-License-Identifier: GPL-2.0
################################################################################
#
# Driver for Xilinx network controllers and boards
# Copyright 2019-2021 Xilinx Inc.
#
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 as published
# by the Free Software Foundation, incorporated herein by reference.
#
################################################################################

ifndef KERNELRELEASE
ifndef EFCT_UPSTREAM
# Compat: KDIR used to be called KPATH
ifdef KPATH
KDIR ?= $(KPATH)
else
KDIR ?= /lib/modules/$(shell uname -r)/build
endif #KPATH
endif #EFCT_UPSTREAM
export-srpm export:
	@mkdir -p $(KDIR)/include/linux/net/xilinx/
	cp -rp net/xilinx/xlnx_efct.h $(KDIR)/include/linux/net/xilinx/.
	chmod 644 $(KDIR)/include/linux/net/xilinx/xlnx_efct.h
endif #KERNELRELEASE
