=== src/xilinx-efct-1.2.5.0/drivers/net/ethernet/xilinx/util/Makefile ===
# SPDX-License-Identifier: BSD-2-Clause
# (c) Copyright 2021 Xilinx, Inc.

TARGETS := set_loopback set_carrier phy_power
TARGETS_RENAME := $(TARGETS:%=$(TARGETS_PREFIX)%)

# This constrained rule is needed so that the default rules do not make
# the executable directly from the .c file

all: $(TARGETS_RENAME)

$(TARGETS_RENAME) : % : %.o
	@echo [LD] $@
	$(Q)$(CC) -o $@ $<

$(TARGETS_PREFIX)%.o: %.c
	@echo [CC] $@
	$(Q)$(CC) -I.. $(CFLAGS) -c -o $@ $<

clean:
	rm -f *.o $(TARGETS_RENAME)
