=== src/xilinx-efct-1.2.5.0/scripts/deb/debian/changelog ===
xilinx-efct-dkms (%VERSION HERE%) unstable; urgency=medium

  * Initial package.

 -- %NAME HERE% <%EMAIL HERE%>  %DATE HERE%
